

%gmm objective function for BLP - passes tol and maxiter to deltafunc.m
%  - just a function of sigma, with alpha and beta concentrated out
%  - second output is derivative
function [out1,out2]=gmm_obj(sigmaval,s,market,xzeta_all,x,zetas,X,Z,W,N,tol,maxiter)

global delta_last

%initial delta for contraction mapping
delta_init_all=delta_last;

deltavals=[];
deltaderivs=[];
for imarket=1:N
  delta_init=delta_init_all(market==imarket);
  delta_i=deltafunc(sigmaval,s(market==imarket),xzeta_all(market==imarket,:),x(market==imarket),zetas,delta_init,tol,maxiter);
  deltavals=[deltavals;delta_i(:,1)];
  deltaderivs=[deltaderivs;delta_i(:,2)];
end
linparams=ivreg(deltavals,X,Z,W);

xihat=deltavals-X*linparams;

%total derivative of Z'xi(sigma,beta(sigma),alpha(sigma)) with respect to sigma
derivZprimexi=Z'*(eye(length(s))-X*inv(X'*Z*W*Z'*X)*X'*Z*W*Z')*deltaderivs;

%update global variable for initial delta for contraction mapping
delta_last=deltavals;

out1=(xihat'*Z)*W*(xihat'*Z)';
out2=2*(xihat'*Z)*W*derivZprimexi;

