

%evaluate lhs of equilibrium condition for random coefficients logit with
%multi product firms (first display of p.854 in BLP)
function out = multi_rclogit_eq(p)

global m xzeta mc ownmat F FS J ns alpha sigma_true;  %mean utility of product i will be m_i+p_in

%row j of column i of szeta is the share of product i among consumers of
%type zeta_i under price vector p
szeta=exp(m*ones(1,ns)-alpha*p*ones(1,ns)+xzeta*sigma_true) ...
    ./(ones(J,1)*sum(exp(m*ones(1,ns)-p*ones(1,ns)+xzeta*sigma_true),1)+1);
s=mean(szeta,2);
Dmatdiag=alpha*mean(szeta.*(1-szeta),2);
%j,kth element of Dmat is the negative of the derivative of the share of
%the kth product with respect to the price if the jth product if the
%products are owned by the same firm, and zero otherwise (3.4 in BLP)
Dmatnondiag=szeta*szeta'/ns;
Dmat=alpha*diag(Dmatdiag)-alpha*(Dmatnondiag.*(ownmat-eye(J)));

out=s-Dmat*(p-mc);


