

%monte carlo for IV estimates of random coefficients logit demand with
%multi product firms and Bertrand competition
%  - this version uses alpha=-1
global m xzeta zetas mc ownmat F FS J N ns alpha sigma_true results;  %mean utility of product i will be m_i+p_i



ownmat=kron(eye(F),ones(FS));

dataset_rclog=zeros(J,nx+nz+3,N,nreps);
dataset_rclog_cm=zeros(J,nx+nz+3,N,nreps);  %prices and shares with markup 1/alpha


beta=[3;6];
gamma=[2;1;1];
alpha=1;
sigma_true=3;  %standard deviation of random coefficients



for irep=1:nreps
for imarket=1:N

  exitflag = 0;
  while exitflag~=1  %simulate datasets until fsolve works for one
  
  x=rand(J,nx);
  temp=rand(J,1);      %generate xi=2*(rho*u1+(1-rho)*u2)-1 and eta=2*(rho*u1+(1-rho)*u2)-1 for
  xi=2*((1-rho)*rand(J,1)+rho*temp)-1;   %u1, u2, u3 iid uniform so that xi and
  eta=2*((1-rho)*rand(J,1)+rho*temp)-1;  %eta are correlated and mean zero
  m=[ones(J,1),x]*beta+xi;
  z=rand(J,1)+1;  %cost instrument
  mc=[ones(J,1),x,z]*gamma+eta;
  xzeta=x*zetas';
  
  
  %solve for prices
  [pfsolve,fval,exitflag]=fsolve(@(x) multi_rclogit_eq(x),4*ones(J,1));
  %multi_logit_eq(pfsolve);  %report equation value at fsolve solution
  
  if exitflag ~= 1
    nosol=nosol+1
  end
  
  end
  
  p=pfsolve;  %use price from fsolve
  %shares
  s=mean(exp(m*ones(1,ns)-alpha*p*ones(1,ns)+xzeta*sigma_true) ...
    ./(ones(J,1)*sum(exp(m*ones(1,ns)-p*ones(1,ns)+xzeta*sigma_true),1)+1),2);
  delta=m-alpha*p;
  dataset_rclog(:,:,imarket,irep)=[s,x,p,z,delta];
  pstar=mc+1/alpha;
  sstar=mean(exp(m*ones(1,ns)-alpha*pstar*ones(1,ns)+xzeta*sigma_true) ...
    ./(ones(J,1)*sum(exp(m*ones(1,ns)-pstar*ones(1,ns)+xzeta*sigma_true),1)+1),2);
  dataset_rclog_cm(:,:,imarket,irep)=[sstar,x,pstar,z,delta];
  


end
end

