

%monte carlo for IV estimates of random coefficients logit demand with
%multi product firms and Bertrand competition

param_ests=zeros(nreps,4);
param_ests_costinst=zeros(nreps,4);
var_ests=zeros(nreps,4,4);
var_ests_costinst=zeros(nreps,4,4);


N=designs_N(iN_design);
%vector with market size for each market
Jvec=[kron(designs_iJ(iJ_design,:)',ones(round(N/3),1));designs_iJ(iJ_design,3)];
Jvec=Jvec(1:N);
%vector with firm size for each market
FSvec=[kron(designs_iFS(iFS_design,:)',ones(round(N/3),1));designs_iFS(iFS_design,3)];
FSvec=[FSvec((round(N/6)+1):N);FSvec(1:round(N/6))];

sigmainit=3;  %initial sigma for gmm objective

tol=.000001;
maxiter=3000;
options=optimset('fminunc');
options=optimset(options,'GradObj','on');


for irep=1:nreps
  %form data set from N markets from datasets variable with different market and firm sizes
  s=[];
  x=[];
  p=[];
  z=[];
  delta=[];
  market=[];
  sumx=[];  %sum of x in market
  sumxf=[];  %sum of x in market owned by same firm
  
  for imarket=1:N
  %take data from dataset with Jvec(imarket) products and FSvec(imarket) products per firm
  data=datasets{Jvec(imarket),FSvec(imarket)}(:,:,imarket,irep);
  
  J=Jvals(Jvec(imarket));
  FS=FSvals(FSvec(imarket));
  F=J/FS;
  ownmat=kron(eye(F),ones(FS));
  
  s=[s;data(:,1)];
  x=[x;data(:,2)];
  p=[p;data(:,3)];
  z=[z;data(:,4)];
  delta=[delta;data(:,5)];
  market=[market;imarket*ones(J,1)];
  sumx=[sumx;sum(data(:,2))*ones(J,1)];
  sumxf=[sumxf;ownmat*data(:,2)];
  end
  

  %estimate model
  xzeta_all=x*zetas';  %x*zeta stacked for all markets - will cycle through these in gmm_obj when doing delta function inversion
  X=[ones(length(s),1),x,p];
  Z=[ones(length(s),1),x,sumx,sumxf];
  W=inv(Z'*Z);
  
  %initialize global variable for initial guess of delta
  delta_last=ones(length(s),1);


  [sigmahat,minobj]=fmincon(@(t) gmm_obj(t,s,market,xzeta_all,x,zetas,X,Z,W,N,tol,maxiter),sigmainit,-1,0,[],[],[],[],[],options)

  param_ests(irep,:)=[linparam_est(sigmahat,s,market,xzeta_all,x,zetas,X,Z,W,N,tol,maxiter)',sigmahat];
  var_ests(irep,:,:)=varhat(sigmahat,s,market,xzeta_all,x,zetas,X,Z,W,N,tol,maxiter);
  
  Zcostinst=[ones(length(s),1),x,z,z.^2];
  Wcostinst=inv(Zcostinst'*Zcostinst);
  [sigmahat_costinst,minobj_costinst]=fmincon(@(t) gmm_obj(t,s,market,xzeta_all,x,zetas,X,Zcostinst,Wcostinst,N,tol,maxiter),sigmainit,-1,0,[],[],[],[],[],options)
  param_ests_costinst(irep,:)=[linparam_est(sigmahat_costinst,s,market,xzeta_all,x,zetas,X,Zcostinst,Wcostinst,N,tol,maxiter)',sigmahat_costinst];
  var_ests_costinst(irep,:,:)=varhat(sigmahat_costinst,s,market,xzeta_all,x,zetas,X,Zcostinst,Wcostinst,N,tol,maxiter);
  
end

