

%generate data sets for random coefficients logit monte carlo and save them

global m zetas xzeta mc ownmat F FS J N ns alpha sigma_true results;
rand('seed',12345678);
randn('seed',12345678);

ns=10;  %number of simulation draws for random coefficients
%draws of random coefficients will be the same across markets and treated as known
%(up to variance term sigma) and used in estimation
zetas=randn(ns,1);
Jvals=[20,60,100];
FSvals=[2,5,10];
N=20;  %(maximum) number of markets
nreps=1000;
nx=1;  %number of characteristics (without constant)
nz=1;  %number of cost instruments
datasets=cell(length(Jvals),length(FSvals));
datasets_cm=cell(length(Jvals),length(FSvals));  %data sets generated with constant markup 1/alpha

rho=.5;  %parameter governing correlation of cost and demand shocks

nosol = 0  %number of times fsolve has failed - will be incremented in
           %multi_logit_monte_singlemarket

for iJ=1:length(Jvals)
  for iFS=1:length(FSvals)
    J=Jvals(iJ)
    FS=FSvals(iFS)
    F=J/FS
    
    multi_rclogit_gen_dataset
   
    datasets{iJ,iFS}=dataset_rclog;
    datasets_cm{iJ,iFS}=dataset_rclog_cm;
  end
end


save('multi_rclogit_datasets','datasets','zetas','Jvals','FSvals','nosol','rho','-v7.3');
save('multi_rclogit_datasets_cm','datasets_cm','zetas','Jvals','FSvals','nosol','rho','-v7.3');

