

%run monte carlo for random coefficients logit based on data with
%constant markups generated from run_datagen_multi_rclogit.m

%keep track of last value of delta so that deltafunc initializes
%at delta(sigma) for last value of sigma gmm_obj was evaluated
%at, reinitializing at each maximization
global delta_last

load('./mc_datasets/multi_rclogit_datasets_cm.mat')
datasets=datasets_cm;
clear datasets_cm

nreps=length(datasets{1,1}(1,1,1,:))
Nmax=length(datasets{1,1}(1,1,:,1))


%indices of number of products per market for each design
% - each row is a design, with 1/3 of markets in that design having the
%number of products with each of the three indices in that row
designs_iJ=[1,1,1;
            1,2,3;
            2,2,2;
            3,3,3]
%indices of firm size (similar setup to designs_iJ)
designs_iFS=[1,2,3;
             1,1,1;
             3,3,3]
%sample sizes for each design
designs_N=[3;20];

%will hold parameter estimates for each monte carlo replication
param_ests_all=zeros(length(designs_iJ(:,1)),length(designs_iFS(:,1)),length(designs_N),nreps,4);
param_ests_costinst_all=zeros(length(designs_iJ(:,1)),length(designs_iFS(:,1)),length(designs_N),nreps,4);
%will hold estimates of variance of parameter estimats
var_ests_all=zeros(length(designs_iJ(:,1)),length(designs_iFS(:,1)),length(designs_N),nreps,4,4);
var_ests_costinst_all=zeros(length(designs_iJ(:,1)),length(designs_iFS(:,1)),length(designs_N),nreps,4,4);

tic


for iJ_design=1:length(designs_iJ(:,1))
  for iFS_design=1:length(designs_iFS(:,1))
    for iN_design=1:length(designs_N)
    
    multi_rclogit_monte
    
    param_ests_all(iJ_design,iFS_design,iN_design,:,:)=param_ests;
    param_ests_costinst_all(iJ_design,iFS_design,iN_design,:,:)=param_ests_costinst;
    var_ests_all(iJ_design,iFS_design,iN_design,:,:,:)=var_ests;
    var_ests_costinst_all(iJ_design,iFS_design,iN_design,:,:,:)=var_ests_costinst;

    end
  end
end

toc

save('multi_rclogit_mc_ests_cm','param_ests_all','param_ests_costinst_all','var_ests_all','var_ests_costinst_all','designs_iJ','designs_iFS','designs_N','rho','-v7.3');

