

%summarize output from run_monte_multi_rclogit.m,
%run_monte_multi_rclogit_singlemarket.m, etc. (change which of
%first few lines are commented to summarize different output)


%load('./mc_datasets/multi_rclogit_mc_ests.mat')
%load('./mc_datasets/multi_rclogit_mc_ests_cm.mat')
%load('./mc_datasets/multi_rclogit_mc_ests_limmark.mat')
%load('./mc_datasets/multi_rclogit_mc_ests_singlemarket.mat')
load('./mc_datasets/multi_rclogit_mc_ests_singlemarket_cm.mat')

%repetitions
nreps=1000

alpha_true=1;

%table with median bias, median absolute deviation from true value, size for wald teset of alpha=1, power for wald test of alpha=0 (not size corrected)
sum_table=zeros(length(designs_iJ(:,1))*length(designs_iFS(:,1))*length(designs_N),3+4);
sum_table_costist=zeros(length(designs_iJ(:,1))*length(designs_iFS(:,1))*length(designs_N),3+4);

%number of estimats that did not converge
num_isnan=zeros(length(designs_iJ(:,1))*length(designs_iFS(:,1))*length(designs_N),3+2);
num_isnan_costinst=zeros(length(designs_iJ(:,1))*length(designs_iFS(:,1))*length(designs_N),3+2);

i=1
for iN_design=1:length(designs_N)
  for iFS_design=1:length(designs_iFS(:,1))
    for iJ_design=1:length(designs_iJ(:,1))


    alpha_ests=zeros(nreps,1);
    alpha_ses=zeros(nreps,1);
    alpha_ests_costinst=zeros(nreps,1);
    alpha_ses_costinst=zeros(nreps,1);
    
      for irep=1:nreps

      param_est=param_ests_all(iJ_design,iFS_design,iN_design,irep,:);
      param_est_costinst=param_ests_costinst_all(iJ_design,iFS_design,iN_design,irep,:);
      var_est=var_ests_all(iJ_design,iFS_design,iN_design,irep,:,:);
      var_est_costinst=var_ests_costinst_all(iJ_design,iFS_design,iN_design,irep,:,:);
      
      alpha_ests(irep)=-param_est(3);
      alpha_ses(irep)=sqrt(var_ests_all(iJ_design,iFS_design,iN_design,irep,3,3));
      alpha_ests_costinst(irep)=-param_est_costinst(3);
      alpha_ses_costinst(irep)=sqrt(var_ests_costinst_all(iJ_design,iFS_design,iN_design,irep,3,3));
      end
    
    %take only estimates that converged, keep track of how many did not
    alpha_ests=alpha_ests(~isnan(alpha_ests));
    alpha_ses=alpha_ses(~isnan(alpha_ests));
    alpha_ests_costinst=alpha_ests_costinst(~isnan(alpha_ests_costinst));
    alpha_ses_costinst=alpha_ses_costinst(~isnan(alpha_ests_costinst));

    num_isnan(i,:)=[iN_design,iFS_design,iJ_design,sum(isnan(alpha_ests)),sum(isnan(alpha_ses))];
    num_isnan_costinst(i,:)=[iN_design,iFS_design,iJ_design,sum(isnan(alpha_ests_costinst)),sum(isnan(alpha_ses_costinst))];
    
    med_bias=median(alpha_ests)-alpha_true;
    med_abs_dev=median(abs(alpha_ests-alpha_true*ones(length(alpha_ests),1)));
    size=mean(abs(alpha_ests-alpha_true*ones(length(alpha_ests),1))>1.96*alpha_ses);
    power=mean(abs(alpha_ests)>1.96*alpha_ses);

    med_bias_costinst=median(alpha_ests_costinst)-alpha_true;
    med_abs_dev_costinst=median(abs(alpha_ests_costinst-alpha_true*ones(length(alpha_ests_costinst),1)));
    size_costinst=mean(abs(alpha_ests_costinst-alpha_true*ones(length(alpha_ests_costinst),1))>1.96*alpha_ses_costinst);
    power_costinst=mean(abs(alpha_ests_costinst)>1.96*alpha_ses_costinst);
    
    sum_table(i,:)=[iN_design,iFS_design,iJ_design,med_bias,med_abs_dev,size,power];
    sum_table_costinst(i,:)=[iN_design,iFS_design,iJ_design,med_bias_costinst,med_abs_dev_costinst,size_costinst,power_costinst];
    
    i=i+1;
    end
  end
end

%summary for blp instruments
sum_table

%summary for cost instruments
sum_table_costinst

%number of estimates with nans for blp instruments 
num_isnan
%number of estimates with nans for cost instruments 
num_isnan_costinst

