

%variance estimate for BLP - passes tol and maxiter to deltafunc.m
%  - just a function of sigma, with alpha and beta concentrated out
function out=varhat(sigmaval,s,market,xzeta_all,x,zetas,X,Z,W,N,tol,maxiter)

global delta_last

%initial delta for contraction mapping
delta_init_all=delta_last;

deltavals=[];
deltaderivs=[];
for imarket=1:N
  %delta_init=log(s(market==imarket))-log(1-sum(s(market==imarket)));
  %delta_init=ones(length(s(market==imarket)),1);
  delta_init=delta_init_all(market==imarket);
  delta_i=deltafunc(sigmaval,s(market==imarket),xzeta_all(market==imarket,:),x(market==imarket),zetas,delta_init,tol,maxiter);
  deltavals=[deltavals;delta_i(:,1)];
  deltaderivs=[deltaderivs;delta_i(:,2)];
end
linparams=ivreg(deltavals,X,Z,W);

xihat=deltavals-X*linparams;

sumxiZ=Z'*diag(xihat.^2)*Z;
derivxiZ=Z'*[-X,deltaderivs];

%update global variable for initial delta for contraction mapping
delta_last=deltavals;

out=inv(derivxiZ'*W*derivxiZ)*derivxiZ'*W*sumxiZ*W*derivxiZ*inv(derivxiZ'*W*derivxiZ);

